diff --git a/contrib/gmm/gmm_matrix.h b/contrib/gmm/gmm_matrix.h
index 09946f09e5..771a246f45 100644
--- a/contrib/gmm/gmm_matrix.h
+++ b/contrib/gmm/gmm_matrix.h
@@ -649,82 +664,77 @@ namespace gmm
     void init_with(const csr_matrix_ref<PT1,PT2,PT3,cshift>& B)
     { init_with_good_format(B); }
     template <typename U, int cshift>
-    void init_with(const csr_matrix<U, cshift>& B)
+    void init_with(const csr_matrix<U, IND_TYPE, cshift>& B)
     { init_with_good_format(B); }
 
     template <typename Matrix> void init_with(const Matrix &A);
     void init_with_identity(size_type n);
 
-    csr_matrix(void) : pr(0), ir(0), jc(0), nc(0), nr(0) {}
+    csr_matrix(void) : nc(0), nr(0) {}
     csr_matrix(size_type nnr, size_type nnc);
-    ~csr_matrix() { if (pr) { delete[] pr; delete[] ir; delete[] jc; } }
 
     size_type nrows(void) const { return nr; }
     size_type ncols(void) const { return nc; }
-    void swap(csr_matrix<T, shift> &m) { 
-      std::swap(pr, m.pr); 
-      std::swap(ir,m.ir); std::swap(jc, m.jc); 
+    void swap(csr_matrix<T, IND_TYPE, shift> &m) {
+      std::swap(pr, m.pr);
+      std::swap(ir,m.ir); std::swap(jc, m.jc);
       std::swap(nc, m.nc); std::swap(nr,m.nr);
     }
-   
+
     value_type operator()(size_type i, size_type j) const
     { return mat_row(*this, i)[j]; }
   };
-  
-  template <typename T, int shift> template <typename Matrix>
-  void csr_matrix<T, shift>::init_with_good_format(const Matrix &B) {
+
+  template <typename T, typename IND_TYPE, int shift> template <typename Matrix>
+  void csr_matrix<T, IND_TYPE, shift>::init_with_good_format(const Matrix &B) {
     typedef typename linalg_traits<Matrix>::const_sub_row_type row_type;
-    if (pr) { delete[] pr; delete[] ir; delete[] jc; }
     nc = mat_ncols(B); nr = mat_nrows(B);
-    jc = new IND_TYPE[nr+1];
+    jc.resize(nr+1);
     jc[0] = shift;
     for (size_type j = 0; j < nr; ++j) {
-      jc[j+1] = jc[j] + nnz(mat_const_row(B, j));
+      jc[j+1] = IND_TYPE(jc[j] + nnz(mat_const_row(B, j)));
     }
-    pr = new T[jc[nr]];
-    ir = new IND_TYPE[jc[nr]];
+    pr.resize(jc[nr]);
+    ir.resize(jc[nr]);
     for (size_type j = 0; j < nr; ++j) {
       row_type row = mat_const_row(B, j);
-      typename linalg_traits<row_type>::const_iterator
-	it = vect_const_begin(row), ite = vect_const_end(row);
-      for (size_type k = 0; it != ite; ++it, ++k)
-	{ pr[jc[j]-shift+k] = *it; ir[jc[j]-shift+k] = it.index()+shift; }
+      typename linalg_traits<typename org_type<row_type>::t>::const_iterator
+        it = vect_const_begin(row), ite = vect_const_end(row);
+      for (size_type k = 0; it != ite; ++it, ++k) {
+        pr[jc[j]-shift+k] = *it;
+        ir[jc[j]-shift+k] = IND_TYPE(it.index()+shift);
+      }
     }
   }
 
-  template <typename T, int shift> template <typename Matrix> 
-  void csr_matrix<T, shift>::init_with(const Matrix &A) { 
-    row_matrix<wsvector<T> > B(mat_nrows(A), mat_ncols(A)); 
-    copy(A, B); 
+  template <typename T, typename IND_TYPE, int shift> template <typename Matrix>
+  void csr_matrix<T, IND_TYPE, shift>::init_with(const Matrix &A) {
+    row_matrix<wsvector<T> > B(mat_nrows(A), mat_ncols(A));
+    copy(A, B);
     init_with_good_format(B);
   }
 
-  template <typename T, int shift> 
-  void csr_matrix<T, shift>::init_with_identity(size_type n) {
-    if (pr) { delete[] pr; delete[] ir; delete[] jc; }
-    nc = nr = n; 
-    pr = new T[nr];
-    ir = new IND_TYPE[nr];
-    jc = new IND_TYPE[nr+1];
+  template <typename T, typename IND_TYPE, int shift>
+  void csr_matrix<T, IND_TYPE, shift>::init_with_identity(size_type n) {
+    nc = nr = n;
+    pr.resize(nr); ir.resize(nr); jc.resize(nr+1);
     for (size_type j = 0; j < nr; ++j)
       { ir[j] = jc[j] = shift + j; pr[j] = T(1); }
     jc[nr] = shift + nr;
   }
 
-  template <typename T, int shift>
-  csr_matrix<T, shift>::csr_matrix(size_type nnr, size_type nnc)
+  template <typename T, typename IND_TYPE, int shift>
+  csr_matrix<T, IND_TYPE, shift>::csr_matrix(size_type nnr, size_type nnc)
     : nc(nnc), nr(nnr) {
-    pr = new T[1];  ir = new IND_TYPE[1];
-    jc = new IND_TYPE[nr+1];
+    pr.resize(1);  ir.resize(1); jc.resize(nr+1);
     for (size_type j = 0; j < nr; ++j) jc[j] = shift;
     jc[nr] = shift;
   }
 
 
-  template <typename T, int shift>
-  struct linalg_traits<csr_matrix<T, shift> > {
-    typedef csr_matrix<T, shift> this_type;
-    typedef typename this_type::IND_TYPE IND_TYPE;
+  template <typename T, typename IND_TYPE, int shift>
+  struct linalg_traits<csr_matrix<T, IND_TYPE, shift> > {
+    typedef csr_matrix<T, IND_TYPE, shift> this_type;
     typedef linalg_const is_reference;
     typedef abstract_matrix linalg_type;
     typedef T value_type;
@@ -739,7 +749,7 @@ namespace gmm
     typedef cs_vector_ref<const T *, const IND_TYPE *, shift>
     const_sub_row_type;
     typedef sparse_compressed_iterator<const T *, const IND_TYPE *,
-				       const IND_TYPE *, shift>
+                                       const IND_TYPE *, shift>
     const_row_iterator;
     typedef abstract_null_type row_iterator;
     typedef row_major sub_orientation;
@@ -747,37 +757,37 @@ namespace gmm
     static size_type nrows(const this_type &m) { return m.nrows(); }
     static size_type ncols(const this_type &m) { return m.ncols(); }
     static const_row_iterator row_begin(const this_type &m)
-    { return const_row_iterator(m.pr, m.ir, m.jc, m.nc, m.pr); }
+    { return const_row_iterator(&m.pr[0], &m.ir[0], &m.jc[0], m.nc, &m.pr[0]); }
     static const_row_iterator row_end(const this_type &m)
-    { return const_row_iterator(m.pr, m.ir, m.jc + m.nr, m.nc, m.pr); }
+    { return const_row_iterator(&m.pr[0], &m.ir[0], &m.jc[0] + m.nr, m.nc, &m.pr[0]); }
     static const_sub_row_type row(const const_row_iterator &it) {
       return const_sub_row_type(it.pr + *(it.jc) - shift,
-				it.ir + *(it.jc) - shift,
-				*(it.jc + 1) - *(it.jc), it.n);
+                                it.ir + *(it.jc) - shift,
+                                *(it.jc + 1) - *(it.jc), it.n);
     }
-    static const origin_type* origin(const this_type &m) { return m.pr; }
+    static const origin_type* origin(const this_type &m) { return &m.pr[0]; }
     static void do_clear(this_type &m) { m.do_clear(); }
     static value_type access(const const_row_iterator &itrow, size_type j)
     { return row(itrow)[j]; }
   };
 
-  template <typename T, int shift>
+  template <typename T, typename IND_TYPE, int shift>
   std::ostream &operator <<
-    (std::ostream &o, const csr_matrix<T, shift>& m)
+    (std::ostream &o, const csr_matrix<T, IND_TYPE, shift>& m)
   { gmm::write(o,m); return o; }
-  
-  template <typename T, int shift>
-  inline void copy(const identity_matrix &, csr_matrix<T, shift>& M)
+
+  template <typename T, typename IND_TYPE, int shift>
+  inline void copy(const identity_matrix &, csr_matrix<T, IND_TYPE, shift>& M)
   { M.init_with_identity(mat_nrows(M)); }
 
-  template <typename Matrix, typename T, int shift>
-  inline void copy(const Matrix &A, csr_matrix<T, shift>& M)
+  template <typename Matrix, typename T, typename IND_TYPE, int shift>
+  inline void copy(const Matrix &A, csr_matrix<T, IND_TYPE, shift>& M)
   { M.init_with(A); }
 
   /* ******************************************************************** */
-  /*		                                            		  */
-  /*		Block matrix                                		  */
-  /*		                                            		  */
+  /*                                                                      */
+  /*             Block matrix                                             */
+  /*                                                                      */
   /* ******************************************************************** */
 
   template <typename MAT> class block_matrix {
@@ -797,7 +807,7 @@ namespace gmm
     size_type ncolblocks(void) const { return ncolblocks_; }
     const sub_interval &subrowinterval(size_type i) const { return introw[i]; }
     const sub_interval &subcolinterval(size_type i) const { return intcol[i]; }
-    const MAT &block(size_type i, size_type j) const 
+    const MAT &block(size_type i, size_type j) const
     { return blocks[j*ncolblocks_+i]; }
     MAT &block(size_type i, size_type j)
     { return blocks[j*ncolblocks_+i]; }
@@ -806,20 +816,20 @@ namespace gmm
     value_type operator() (size_type i, size_type j) const {
       size_type k, l;
       for (k = 0; k < nrowblocks_; ++k)
-	if (i >= introw[k].min && i <  introw[k].max) break;
+        if (i >= introw[k].min && i <  introw[k].max) break;
       for (l = 0; l < nrowblocks_; ++l)
-	if (j >= introw[l].min && j <  introw[l].max) break;
+        if (j >= introw[l].min && j <  introw[l].max) break;
       return (block(k, l))(i - introw[k].min, j - introw[l].min);
     }
     reference operator() (size_type i, size_type j) {
       size_type k, l;
       for (k = 0; k < nrowblocks_; ++k)
-	if (i >= introw[k].min && i <  introw[k].max) break;
+        if (i >= introw[k].min && i <  introw[k].max) break;
       for (l = 0; l < nrowblocks_; ++l)
-	if (j >= introw[l].min && j <  introw[l].max) break;
+        if (j >= introw[l].min && j <  introw[l].max) break;
       return (block(k, l))(i - introw[k].min, j - introw[l].min);
     }
-    
+
     template <typename CONT> void resize(const CONT &c1, const CONT &c2);
     template <typename CONT> block_matrix(const CONT &c1, const CONT &c2)
     { resize(c1, c2); }
@@ -850,17 +860,17 @@ namespace gmm
     static origin_type* origin(this_type &m) { return &m; }
     static const origin_type* origin(const this_type &m) { return &m; }
     static void do_clear(this_type &m) { m.do_clear(); }
-    // access to be done ...    
+    // access to be done ...
     static void resize(this_type &, size_type , size_type)
     { GMM_ASSERT1(false, "Sorry, to be done"); }
     static void reshape(this_type &, size_type , size_type)
     { GMM_ASSERT1(false, "Sorry, to be done"); }
   };
 
-  template <typename MAT> void block_matrix<MAT>::do_clear(void) { 
+  template <typename MAT> void block_matrix<MAT>::do_clear(void) {
     for (size_type j = 0; j < ncolblocks_; ++j)
       for (size_type i = 0; i < nrowblocks_; ++i)
-	clear(block(i,j));
+        clear(block(i,j));
   }
 
   template <typename MAT> template <typename CONT>
@@ -872,8 +882,8 @@ namespace gmm
     for (size_type j = 0, l = 0; j < ncolblocks_; ++j) {
       intcol[j] = sub_interval(l, c2[j]); l += c2[j];
       for (size_type i = 0, k = 0; i < nrowblocks_; ++i) {
-	if (j == 0) { introw[i] = sub_interval(k, c1[i]); k += c1[i]; }
-	block(i, j) = MAT(c1[i], c2[j]);
+        if (j == 0) { introw[i] = sub_interval(k, c1[i]); k += c1[i]; }
+        block(i, j) = MAT(c1[i], c2[j]);
       }
     }
   }
@@ -882,14 +892,14 @@ namespace gmm
   void copy(const block_matrix<M1> &m1, M2 &m2) {
     for (size_type j = 0; j < m1.ncolblocks(); ++j)
       for (size_type i = 0; i < m1.nrowblocks(); ++i)
-	copy(m1.block(i,j), sub_matrix(m2, m1.subrowinterval(i), 
-				       m1.subcolinterval(j)));
+        copy(m1.block(i,j), sub_matrix(m2, m1.subrowinterval(i),
+                                       m1.subcolinterval(j)));
   }
 
   template <typename M1, typename M2>
   void copy(const block_matrix<M1> &m1, const M2 &m2)
   { copy(m1, linalg_const_cast(m2)); }
-  
+
 
   template <typename MAT, typename V1, typename V2>
   void mult(const block_matrix<MAT> &m, const V1 &v1, V2 &v2) {
@@ -897,9 +907,9 @@ namespace gmm
     typename sub_vector_type<V2 *, sub_interval>::vector_type sv;
     for (size_type i = 0; i < m.nrowblocks() ; ++i)
       for (size_type j = 0; j < m.ncolblocks() ; ++j) {
-	sv = sub_vector(v2, m.subrowinterval(i));
-	mult(m.block(i,j),
-	     sub_vector(v1, m.subcolinterval(j)), sv, sv);
+        sv = sub_vector(v2, m.subrowinterval(i));
+        mult(m.block(i,j),
+             sub_vector(v1, m.subcolinterval(j)), sv, sv);
       }
   }
 
@@ -908,16 +918,16 @@ namespace gmm
     typename sub_vector_type<V3 *, sub_interval>::vector_type sv;
     for (size_type i = 0; i < m.nrowblocks() ; ++i)
       for (size_type j = 0; j < m.ncolblocks() ; ++j) {
-	sv = sub_vector(v3, m.subrowinterval(i));
-	if (j == 0)
-	  mult(m.block(i,j),
-	       sub_vector(v1, m.subcolinterval(j)),
-	       sub_vector(v2, m.subrowinterval(i)), sv);
-	else
-	  mult(m.block(i,j),
-	       sub_vector(v1, m.subcolinterval(j)), sv, sv);
+        sv = sub_vector(v3, m.subrowinterval(i));
+        if (j == 0)
+          mult(m.block(i,j),
+               sub_vector(v1, m.subcolinterval(j)),
+               sub_vector(v2, m.subrowinterval(i)), sv);
+        else
+          mult(m.block(i,j),
+               sub_vector(v1, m.subcolinterval(j)), sv, sv);
       }
-    
+
   }
 
   template <typename MAT, typename V1, typename V2>
@@ -925,22 +935,24 @@ namespace gmm
   { mult(m, v1, linalg_const_cast(v2)); }
 
   template <typename MAT, typename V1, typename V2, typename V3>
-  void mult(const block_matrix<MAT> &m, const V1 &v1, const V2 &v2, 
-	    const V3 &v3)
+  void mult(const block_matrix<MAT> &m, const V1 &v1, const V2 &v2,
+            const V3 &v3)
   { mult_const(m, v1, v2, linalg_const_cast(v3)); }
 
 }
   /* ******************************************************************** */
-  /*		                                            		  */
-  /*		Distributed matrices                                	  */
-  /*		                                            		  */
+  /*                                                                      */
+  /*             Distributed matrices                                     */
+  /*                                                                      */
   /* ******************************************************************** */
 
 #ifdef GMM_USES_MPI
-#include <mpi.h>
- 
-namespace gmm { 
-  
+# include <mpi.h>
+
+namespace gmm {
+
+
+
   template <typename T> inline MPI_Datatype mpi_type(T)
   { GMM_ASSERT1(false, "Sorry unsupported type"); return MPI_FLOAT; }
   inline MPI_Datatype mpi_type(double) { return MPI_DOUBLE; }
@@ -952,13 +964,8 @@ namespace gmm {
 #endif
   inline MPI_Datatype mpi_type(int) { return MPI_INT; }
   inline MPI_Datatype mpi_type(unsigned int) { return MPI_UNSIGNED; }
-  inline MPI_Datatype mpi_type(size_t) {
-    if (sizeof(int) == sizeof(size_t)) return MPI_UNSIGNED;
-    if (sizeof(long) == sizeof(size_t)) return MPI_UNSIGNED_LONG;
-    return MPI_LONG_LONG;
-  }
-
-
+  inline MPI_Datatype mpi_type(long) { return MPI_LONG; }
+  inline MPI_Datatype mpi_type(unsigned long) { return MPI_UNSIGNED_LONG; }
 
   template <typename MAT> struct mpi_distributed_matrix {
     MAT M;
@@ -969,7 +976,7 @@ namespace gmm {
     const MAT &local_matrix(void) const { return M; }
     MAT &local_matrix(void) { return M; }
   };
-  
+
   template <typename MAT> inline MAT &eff_matrix(MAT &m) { return m; }
   template <typename MAT> inline
   const MAT &eff_matrix(const MAT &m) { return m; }
@@ -977,29 +984,29 @@ namespace gmm {
   MAT &eff_matrix(mpi_distributed_matrix<MAT> &m) { return m.M; }
   template <typename MAT> inline
   const MAT &eff_matrix(const mpi_distributed_matrix<MAT> &m) { return m.M; }
-  
+
 
   template <typename MAT1, typename MAT2>
   inline void copy(const mpi_distributed_matrix<MAT1> &m1,
-		   mpi_distributed_matrix<MAT2> &m2)
+                   mpi_distributed_matrix<MAT2> &m2)
   { copy(eff_matrix(m1), eff_matrix(m2)); }
   template <typename MAT1, typename MAT2>
   inline void copy(const mpi_distributed_matrix<MAT1> &m1,
-		   const mpi_distributed_matrix<MAT2> &m2)
+                   const mpi_distributed_matrix<MAT2> &m2)
   { copy(m1.M, m2.M); }
-  
+
   template <typename MAT1, typename MAT2>
   inline void copy(const mpi_distributed_matrix<MAT1> &m1, MAT2 &m2)
   { copy(m1.M, m2); }
   template <typename MAT1, typename MAT2>
   inline void copy(const mpi_distributed_matrix<MAT1> &m1, const MAT2 &m2)
   { copy(m1.M, m2); }
-  
+
 
   template <typename MATSP, typename V1, typename V2> inline
   typename strongest_value_type3<V1,V2,MATSP>::value_type
   vect_sp(const mpi_distributed_matrix<MATSP> &ps, const V1 &v1,
-	  const V2 &v2) {
+          const V2 &v2) {
     typedef typename strongest_value_type3<V1,V2,MATSP>::value_type T;
     T res = vect_sp(ps.M, v1, v2), rest;
     MPI_Allreduce(&res, &rest, 1, mpi_type(T()), MPI_SUM,MPI_COMM_WORLD);
@@ -1008,7 +1015,7 @@ namespace gmm {
 
   template <typename MAT, typename V1, typename V2>
   inline void mult_add(const mpi_distributed_matrix<MAT> &m, const V1 &v1,
-		       V2 &v2) {
+                       V2 &v2) {
     typedef typename linalg_traits<V2>::value_type T;
     std::vector<T> v3(vect_size(v2)), v4(vect_size(v2));
     static double tmult_tot = 0.0;
@@ -1018,7 +1025,7 @@ namespace gmm {
     if (is_sparse(v2)) GMM_WARNING2("Using a plain temporary, here.");
     double t_ref2 = MPI_Wtime();
     MPI_Allreduce(&(v3[0]), &(v4[0]),gmm::vect_size(v2), mpi_type(T()),
-		  MPI_SUM,MPI_COMM_WORLD);
+                  MPI_SUM,MPI_COMM_WORLD);
     tmult_tot2 = MPI_Wtime()-t_ref2;
     cout << "reduce mult mpi = " << tmult_tot2 << endl;
     gmm::add(v4, v2);
@@ -1028,59 +1035,59 @@ namespace gmm {
 
   template <typename MAT, typename V1, typename V2>
   void mult_add(const mpi_distributed_matrix<MAT> &m, const V1 &v1,
-		const V2 &v2_)
+                const V2 &v2_)
   { mult_add(m, v1, const_cast<V2 &>(v2_)); }
 
   template <typename MAT, typename V1, typename V2>
   inline void mult(const mpi_distributed_matrix<MAT> &m, const V1 &v1,
-		   const V2 &v2_)
+                   const V2 &v2_)
   { V2 &v2 = const_cast<V2 &>(v2_); clear(v2); mult_add(m, v1, v2); }
 
   template <typename MAT, typename V1, typename V2>
   inline void mult(const mpi_distributed_matrix<MAT> &m, const V1 &v1,
-		   V2 &v2)
+                   V2 &v2)
   { clear(v2); mult_add(m, v1, v2); }
 
   template <typename MAT, typename V1, typename V2, typename V3>
   inline void mult(const mpi_distributed_matrix<MAT> &m, const V1 &v1,
-		   const V2 &v2, const V3 &v3_)
+                   const V2 &v2, const V3 &v3_)
   { V3 &v3 = const_cast<V3 &>(v3_); gmm::copy(v2, v3); mult_add(m, v1, v3); }
 
   template <typename MAT, typename V1, typename V2, typename V3>
   inline void mult(const mpi_distributed_matrix<MAT> &m, const V1 &v1,
-		   const V2 &v2, V3 &v3)
+                   const V2 &v2, V3 &v3)
   { gmm::copy(v2, v3); mult_add(m, v1, v3); }
-  
+
 
   template <typename MAT> inline
-  size_type mat_nrows(const mpi_distributed_matrix<MAT> &M) 
+  size_type mat_nrows(const mpi_distributed_matrix<MAT> &M)
   { return mat_nrows(M.M); }
   template <typename MAT> inline
-  size_type mat_ncols(const mpi_distributed_matrix<MAT> &M) 
+  size_type mat_ncols(const mpi_distributed_matrix<MAT> &M)
   { return mat_nrows(M.M); }
   template <typename MAT> inline
   void resize(mpi_distributed_matrix<MAT> &M, size_type m, size_type n)
   { resize(M.M, m, n); }
   template <typename MAT> inline void clear(mpi_distributed_matrix<MAT> &M)
   { clear(M.M); }
-  
+
 
   // For compute reduced system
   template <typename MAT1, typename MAT2> inline
   void mult(const MAT1 &M1, const mpi_distributed_matrix<MAT2> &M2,
-	    mpi_distributed_matrix<MAT2> &M3)
+            mpi_distributed_matrix<MAT2> &M3)
   { mult(M1, M2.M, M3.M); }
   template <typename MAT1, typename MAT2> inline
   void mult(const mpi_distributed_matrix<MAT2> &M2,
-	    const MAT1 &M1, mpi_distributed_matrix<MAT2> &M3)
+            const MAT1 &M1, mpi_distributed_matrix<MAT2> &M3)
   { mult(M2.M, M1, M3.M); }
   template <typename MAT1, typename MAT2, typename MAT3> inline
   void mult(const MAT1 &M1, const mpi_distributed_matrix<MAT2> &M2,
-		   MAT3 &M3)
+                   MAT3 &M3)
   { mult(M1, M2.M, M3); }
   template <typename MAT1, typename MAT2, typename MAT3> inline
   void mult(const MAT1 &M1, const mpi_distributed_matrix<MAT2> &M2,
-		   const MAT3 &M3)
+                   const MAT3 &M3)
   { mult(M1, M2.M, M3); }
 
   template <typename M, typename SUBI1, typename SUBI2>
@@ -1101,16 +1108,16 @@ namespace gmm {
   template <typename MAT, typename SUBI1, typename SUBI2>  inline
   typename select_return<typename sub_matrix_type<const MAT *, SUBI1, SUBI2>
   ::matrix_type, typename sub_matrix_type<MAT *, SUBI1, SUBI2>::matrix_type,
-			 const MAT *>::return_type
+                         const MAT *>::return_type
   sub_matrix(const mpi_distributed_matrix<MAT> &m, const SUBI1 &si1,
-	     const SUBI2 &si2)
+             const SUBI2 &si2)
   { return sub_matrix(m.M, si1, si2);  }
 
   template <typename M, typename SUBI1>  inline
     typename select_return<typename sub_matrix_type<const M *, SUBI1, SUBI1>
     ::matrix_type, typename sub_matrix_type<M *, SUBI1, SUBI1>::matrix_type,
     M *>::return_type
-  sub_matrix(mpi_distributed_matrix<M> &m, const SUBI1 &si1) 
+  sub_matrix(mpi_distributed_matrix<M> &m, const SUBI1 &si1)
   { return sub_matrix(m.M, si1, si1); }
 
   template <typename M, typename SUBI1>  inline
@@ -1121,11 +1128,11 @@ namespace gmm {
   { return sub_matrix(m.M, si1, si1); }
 
 
-  template <typename L> struct transposed_return<const mpi_distributed_matrix<L> *> 
+  template <typename L> struct transposed_return<const mpi_distributed_matrix<L> *>
   { typedef abstract_null_type return_type; };
-  template <typename L> struct transposed_return<mpi_distributed_matrix<L> *> 
+  template <typename L> struct transposed_return<mpi_distributed_matrix<L> *>
   { typedef abstract_null_type return_type; };
-  
+
   template <typename L> inline typename transposed_return<const L *>::return_type
   transposed(const mpi_distributed_matrix<L> &l)
   { return transposed(l.M); }
@@ -1174,11 +1181,11 @@ namespace std {
   template <typename T>
   void swap(gmm::dense_matrix<T> &m1, gmm::dense_matrix<T> &m2)
   { m1.swap(m2); }
-  template <typename T, int shift> void 
-  swap(gmm::csc_matrix<T,shift> &m1, gmm::csc_matrix<T,shift> &m2)
+  template <typename T, typename IND_TYPE, int shift> void
+  swap(gmm::csc_matrix<T, IND_TYPE, shift> &m1, gmm::csc_matrix<T, IND_TYPE, shift> &m2)
   { m1.swap(m2); }
-  template <typename T, int shift> void 
-  swap(gmm::csr_matrix<T,shift> &m1, gmm::csr_matrix<T,shift> &m2)
+  template <typename T, typename IND_TYPE, int shift> void
+  swap(gmm::csr_matrix<T, IND_TYPE, shift> &m1, gmm::csr_matrix<T, IND_TYPE, shift> &m2)
   { m1.swap(m2); }
 }
 
diff --git a/contrib/gmm/gmm_modified_gram_schmidt.h b/contrib/gmm/gmm_modified_gram_schmidt.h
index 213cf7a7e0..fa45917641 100644
--- a/contrib/gmm/gmm_modified_gram_schmidt.h
+++ b/contrib/gmm/gmm_modified_gram_schmidt.h
@@ -1,30 +1,60 @@
-// -*- c++ -*- (enables emacs c++ mode)
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2002-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
+
 //===========================================================================
 //
-// Copyright (C) 1997-2008 Yves Renard
-//
-// This file is a part of GETFEM++
+// Copyright (c) 1998-2020, University of Notre Dame. All rights reserved.
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
 //
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+//    * Redistributions of source code must retain the above copyright
+//      notice, this list of conditions and the following disclaimer.
+//    * Redistributions in binary form must reproduce the above copyright
+//      notice, this list of conditions and the following disclaimer in the
+//      documentation and/or other materials provided with the distribution.
+//    * Neither the name of the University of Notre Dame nor the
+//      names of its contributors may be used to endorse or promote products
+//      derived from this software without specific prior written permission.
 //
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
+// THIS SOFTWARE  IS  PROVIDED  BY  THE TRUSTEES  OF  INDIANA UNIVERSITY  AND
+// CONTRIBUTORS  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,  INCLUDING,
+// BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND  FITNESS
+// FOR  A PARTICULAR PURPOSE ARE DISCLAIMED. IN  NO  EVENT SHALL THE TRUSTEES
+// OF INDIANA UNIVERSITY AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+// INCIDENTAL, SPECIAL, EXEMPLARY,  OR CONSEQUENTIAL DAMAGES (INCLUDING,  BUT
+// NOT  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+// DATA,  OR PROFITS;  OR BUSINESS  INTERRUPTION)  HOWEVER  CAUSED AND ON ANY
+// THEORY  OF  LIABILITY,  WHETHER  IN  CONTRACT,  STRICT  LIABILITY, OR TORT
+// (INCLUDING  NEGLIGENCE  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+// THIS  SOFTWARE,  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 //
 //===========================================================================
 
